/**
 * Provides map type class.
 * @author Andre Platzer
 * @version 2003-08-23
 */
:- module adt__abstract_map.
:- interface.
:- use_module map.


/**
 * The type class for mere lookup maps, i.e.
 * maps that only provide read access.
 * @param T the type that is a lookup_map.
 * @param K the type for keys.
 * @param V the type for values.
 * @author Andre Platzer
 * @version 2003-08-23
 */
:- typeclass lookup_map(T, K, V) where [
	/**
	 * Search the map for a key, and if exists return its value.
	 */
	pred search(T, K, V),
        mode search(in, in, out) is semidet

 ].



:- implementation.


:- end_module adt__abstract_map.