/**
 * Provides diverse parser utilities.
 * @author Andre Platzer
 * @version 2003-08-18
 */
:- module parser_util.
:- interface.
:- import_module parsers.

/**
 * Make rule with default concatenation action.
 */
:- func rule(symbol, list(symbol)) = production/*(actionType)*/ is det.
/**
 * Make rule with production information accumulation action.
 */
:- func rule_prod(symbol, list(symbol)) = production/*(actionType)*/ is det.



:- implementation.
:- import_module string, require.

rule_prod(NT,RHS) = rule(NT,RHS,
			 (func(L) = new_action_value("  " ++ to_string(rule(NT,RHS,det_head)) ++ "\n"
					    ++ foldl((func(X,Y) = to_string(X) ++ " " ++ Y), L, ""))
			 )
			).

rule(NT,RHS) = rule_prod(NT,RHS).


:- end_module parser_util.