/**
 * Provides a tokenSequence from a string (with individual characters as tokens).
 * @author Andre Platzer
 * @version 2003-08-25
 */
:- module string_source.
:- interface.
:- import_module scanners, char, basecap, list.

:- type char_tokenSequence.
%%@xxx should abstract this
:- type char_tokenSequence == list(char_token).
%%:- instance printable(char_tokenSequence).
:- instance tokenSequence(char_tokenSequence).

/**
 * Create a tokenSequence from a string source with individual characters as tokens.
 */
:- func string_tokenSequence(string) = char_tokenSequence.
:- mode string_tokenSequence(in) = out is det.

:- type char_token
	---> char_token(
		  signifier :: char
		 )
	;    end_of_file_source.
:- instance printable(char_token).
:- instance token(char_token).



:- implementation.

:- import_module list, string, char, require, std_util, basecap.
:- import_module scanner_util.



string_tokenSequence(Source) = map((func(C) = char_token(C)),
				   to_char_list(Source)).


:- instance printable(char_token) where [
        to_string(char_token(A)) = char_to_string(A),
        to_string(end_of_file_source) = "eof"
].

:- instance token(char_token) where [
	(get_value(char_token(A)) = char_to_string(A)),
	(get_value(end_of_file_source) = A :- error("cannot get_value of " ++ to_string(end_of_file_source))),

        get_kind(char_token(A)) = make_token_kind(char_to_string(A)),
        get_kind(end_of_file_source) = make_token_kind("end_of_file"),

	end_of_file = end_of_file_source
 ].

:- end_module string_source.